<?php

use think\migration\Migrator;
use think\migration\db\Column;

class CreateMetaAdsTable extends Migrator
{
    public function change()
    {
        $table = $this->table('ad_meta_ads');
        $table->addColumn('ad_name', 'string', ['limit' => 255])
            ->addColumn('ad_id', 'string', ['limit' => 255, 'unique' => true])
            ->addColumn('status', 'string', ['limit' => 50])
            ->addColumn('ad_group_id', 'integer')
            ->addForeignKey('ad_group_id', 'meta_ad_groups', 'id', ['delete' => 'CASCADE'])
            ->addColumn('created_at', 'timestamp', ['default' => 'CURRENT_TIMESTAMP'])
            ->addColumn('updated_at', 'timestamp', ['default' => 'CURRENT_TIMESTAMP', 'update' => 'CURRENT_TIMESTAMP'])
            ->create();
    }
}
